# -*- coding: utf-8 -*-

#1a) Nel file sufftree.py è contenuta la definizione della classe 
# SuffixTree che implementa un albero per la memorizzazione strutturata di 
# tutti i suffissi di una stringa s. In tale albero, un suffisso ha una 
# corrispondenza biunivoca con un percorso dalla radice a una foglia, e 
# viceversa. Per garantire sempre questa proprietà, ad s si appende un
# carattere speciale di terminazione, solitamente "$". Uno specifico suffisso 
# si ottiene concatenando le label associate ai nodi su un percorso dalla 
# radice a una foglia.
# Nell'implementazione riportata, un nodo contiene una label e un dizionario 
# per riferire i nodi figli: una chiave è il carattere iniziale della label 
# del figlio riferito, e il valore riferisce il nodo figlio. 
# Per convenzione, la radice ha label "." . Nel file example_suff_tree.pdf è 
# riportata una rappresentazione grafica di un esempio di suffix tree.
#
# Si scriva una funzione count_nodes(sTree) che, fornita in ingresso una 
# istanza della classe SuffixTree, restituisca il numero dei nodi nell'albero,
# contandoli esplicitamente.


def count_nodes(sTree):
    
    def c_n(node): #counts nodes in the subtree rooted in "node"
        return 1+sum(c_n(child) for child in node.children.itervalues())
    
    return c_n(sTree.root)

