# -*- coding: utf-8 -*-

#3a) La struttura e il contenuto di un albero possono essere descritti 
# in forma testuale usando la cosiddetta "notazione Newick".
# Nella notazione Newick, un generico nodo con label X che abbia figli 
# è descritto con "(...)X" - tra parentesi sono riportate le descrizioni 
# dei figli, separate da "," (l'indicazione della label talvolta è opzionale) -
# e un nodo senza figli è descritto soltanto con la sua label. 
# La descrizione Newick di un intero albero è quella della sua radice.
# Si fa notare che la classe SuffixTree del modulo sufftree contiene un metodo
# che restituisce una rappresentazione Newick dell'albero.
# Scrivere una funzione max_depth_nw(nw) che, fornita in ingresso una 
# descrizione Newick, restituisca la profondià massima dell'albero. 
# Si segua la convenzione per cui un albero con la sola radice ha 
# profondità 0, uno con la radice e una sola foglia ha profondità 1, ecc.
#
# Es: SuffixTree('BANANA') --> ($,($,($,NA$)NA)A,BANANA$,($,NA$)NA).
#     max_dept_nw( "($,($,($,NA$)NA)A,BANANA$,($,NA$)NA)." ) --> 3


def max_depth_nw(newick):
    curr_depth, maxd = 0 , 0
    for c in newick:
        if c == '(':
            curr_depth += 1
            maxd = max(maxd, curr_depth)
        elif c ==')':
            curr_depth -= 1
    return maxd

