# -*- coding: utf-8 -*-

#4a) Un suffix tree ci permette di verificare agevolmente se una data 
# stringa p compare come sottostringa di una stringa t di cui abbiamo 
# il suffix tree. L'idea di base è che una qualsiasi sottostringa di t è un 
# prefisso di un suo suffisso.
# Si scriva una funzione is_present(target_st, pattern) che restitusca True 
# nel caso in cui pattern sia contenuto nalla stringa di cui target_st è il 
# suffix tree, False altrimenti.


from sufftree import SuffixTree

def is_present(target_st, pattern):
    
    def is_present_node(node, pattern):
        lab = node.label
        if lab == SuffixTree.rootchar: lab = ""
        
        l = min(len(lab),len(pattern))
        if lab[:l] == pattern[:l]:
            if l == len(pattern):
                return True
            else:
                for c in node.children:
                    if c == pattern[l]:
                        return is_present_node(node.children[c], pattern[l:])
        return False
                    
    return is_present_node(target_st.root, pattern)
    


# Trivially, by exploiting the code already present in class SuffixTree:
def is_present_bis(target_st, pattern):
    
    node, _ = target_st.followPath(pattern)

    return node is not None
