# -*- coding: utf-8 -*-

#4b) Si faccia riferimento alla stringa corrispondente alla sottosequenza 
# dalla posizione 31473 alla posizione 31822 (comprese, convenzione Python)
# della sequenza contenuta nel file AL121577_part.gb. 
# Sfruttando la funzione sviluppata al punto 4a), si stabilisca quali, tra 
# tutte le possibili sequenze di nucleotidi di lunghezza 3, NON sono presenti 
# in tale sottosequenza, e le si scrivano su righe successive del file 
# uso4.txt (ordinate alfabeticamente).


import Bio.SeqIO
from sufftree import SuffixTree
from soluzione4 import is_present

gbfilename = 'AL121577_part.gb'
outfile    = 'uso4.txt'
start, end = 31473 , 31822

#generator for strings with len "slen"
def genseq(slen = 3):
    s = "ACGT"
    l = len(s)
    index, maxindex = 0, l**slen
    
    while index < maxindex:
        myindex = index
        res = []
        for j in xrange(slen):
            res.insert(0, s[myindex%l]) #insert at the beginning
            myindex //= l  #integer division
        yield "".join(res)
        index += 1
            
mystr = str(Bio.SeqIO.read(gbfilename,'genbank').seq)[start:end+1]

myst =  SuffixTree(mystr)

with open(outfile,'w') as fout:
    for s in filter( lambda p: not is_present(myst,p) , genseq()):
        fout.write(s+"\n")



#very naif solution to generate a list with all the possible strings to test:

l=[]
for c1 in "ACGT":
    for c2 in "ACGT":
        for c3 in "ACGT":
            l.append(c1+c2+c3)
        